Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Component.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Component.cs	(revision 17271)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Component.cs	(revision 17271)
@@ -0,0 +1,95 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Core;
+using Newtonsoft.Json;
+
+namespace HeuristicLab.Manufacture {   
+  /*
+  public class ParameterData { //Blueprint, Component,  ?
+    public string Name { get; set; }
+    public string Type { get; set; }
+    public IList<ParameterData> FreeParameters { get; set; }
+    public IList<ParameterData> StaticParameters { get; set; }
+
+  }*/
+
+  public class Component {
+    public string Name { get; set; }
+    public string Type { get; set; }
+    public object Default { get; set; }
+    public string Path { get; set; }
+    public IList<object> Range { get; set; }
+
+    public IList<Component> Parameters { get; set; }
+    public IList<Component> Operators { get; set; }
+
+    [JsonIgnore]
+    public Component this[string index] {
+      get {
+        if (Parameters == null) return null;
+        foreach (var p in Parameters)
+          if (p.Name == index) return p;
+        return null;
+      }
+      set {
+        if (Parameters == null) 
+          Parameters = new List<Component>();
+        Component data = this[index];
+        if (data != null && CheckConstraints(value))
+          Merge(data, value);
+        else
+          Parameters.Add(value);
+      }
+    }
+
+    public override bool Equals(object obj) {
+      if (!(obj is Component)) 
+        return false;
+      else 
+        return obj.Cast<Component>().Name == this.Name;
+    }
+
+    public override int GetHashCode() {
+      return Name.GetHashCode();
+    }
+
+    [JsonIgnore]
+    public IList<Component> ParameterizedItems { get; set; }
+
+    [JsonIgnore]
+    public Component Reference { get; set; }
+
+    #region Helper
+    public static void Merge(Component target, Component from) {
+      target.Name = from.Name ?? target.Name;
+      target.Type = from.Type ?? target.Type;
+      target.Range = from.Range ?? target.Range;
+      target.Path = from.Path ?? target.Path;
+      target.Default = from.Default ?? target.Default;
+      target.Reference = from.Reference ?? target.Reference;
+      target.Parameters = from.Parameters ?? target.Parameters;
+      target.ParameterizedItems = from.ParameterizedItems ?? target.ParameterizedItems;
+    }
+
+    private bool CheckConstraints(Component data) => 
+      data.Range != null && data.Default != null && (
+      IsInRangeList(data.Range, data.Default) ||
+      IsInNumericRange<long>(data.Default, data.Range[0], data.Range[1]) ||
+      IsInNumericRange<double>(data.Default, data.Range[0], data.Range[1]));
+
+    private bool IsInRangeList(IEnumerable<object> list, object value) {
+      foreach (var x in list)
+        if (x.Equals(value)) return true;
+      return false;
+    }
+
+    private bool IsInNumericRange<T>(object value, object min, object max) where T : IComparable =>
+      (value != null && min != null && max != null && value is T && min is T && max is T &&
+        (((T)min).CompareTo(value) == -1 || ((T)min).CompareTo(value) == 0) &&
+        (((T)max).CompareTo(value) == 1 || ((T)max).CompareTo(value) == 0));
+    #endregion
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/HeuristicLab.Manufacture.csproj
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/HeuristicLab.Manufacture.csproj	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/HeuristicLab.Manufacture.csproj	(revision 17271)
@@ -70,5 +70,5 @@
     <Compile Include="Program.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Template.cs" />
+    <Compile Include="Component.cs" />
     <Compile Include="Interfaces\ITypeTransformer.cs" />
     <Compile Include="Transformer.cs" />
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Interfaces/ITypeTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Interfaces/ITypeTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Interfaces/ITypeTransformer.cs	(revision 17271)
@@ -10,6 +10,6 @@
   //IDataProcessor?
   public interface ITypeTransformer {
-    ParameterData Extract(IItem value);
-    void Inject(IItem item, ParameterData data);
+    Component Extract(IItem value);
+    void Inject(IItem item, Component data);
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/JCGenerator.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/JCGenerator.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/JCGenerator.cs	(revision 17271)
@@ -62,7 +62,7 @@
     public string GenerateTemplate(IAlgorithm algorithm, IProblem problem, params string[] freeParameters) {
       algorithm.Problem = problem;
-      ParameterData algorithmData = Transformer.Extract(algorithm);
-      ParameterData problemData = Transformer.Extract(problem);
-      IList<ParameterData> items = algorithmData.ParameterizedItems;
+      Component algorithmData = Transformer.Extract(algorithm);
+      Component problemData = Transformer.Extract(problem);
+      IList<Component> items = algorithmData.ParameterizedItems;
       foreach (var pItem in problemData.ParameterizedItems) items.Add(pItem);
       JArray jsonItems = new JArray();
@@ -93,5 +93,5 @@
       IList<JObject> objToRemove = new List<JObject>();
       TransformNodes(x => {
-        var p = x.ToObject<ParameterData>();
+        var p = x.ToObject<Component>();
 
         /*bool isSelected = false;
@@ -114,5 +114,5 @@
       IList<JObject> objToRemove = new List<JObject>();
       TransformNodes(x => {
-        var p = x.ToObject<ParameterData>();
+        var p = x.ToObject<Component>();
         x.Property("Range")?.Remove();
         if (p.Default == null) objToRemove.Add(x);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/JCInstantiator.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/JCInstantiator.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/JCInstantiator.cs	(revision 17271)
@@ -22,9 +22,9 @@
       Config = JToken.Parse(File.ReadAllText(configFile));
 
-      ParameterData algorithmData = GetData(Config["Metadata"]["Algorithm"].ToString());
+      Component algorithmData = GetData(Config["Metadata"]["Algorithm"].ToString());
       ResolveReferences(algorithmData);
       IAlgorithm algorithm = CreateObject<IAlgorithm>(algorithmData);
      
-      ParameterData problemData = GetData(Config["Metadata"]["Problem"].ToString());
+      Component problemData = GetData(Config["Metadata"]["Problem"].ToString());
       ResolveReferences(problemData);
       IProblem problem = CreateObject<IProblem>(problemData);
@@ -41,5 +41,5 @@
      */
 
-    private void ResolveReferences(ParameterData data) {
+    private void ResolveReferences(Component data) {
       foreach (var p in data.Parameters) {
         if (p.Default is string && p.Reference == null) {
@@ -49,9 +49,9 @@
     }
 
-    private ParameterData GetData(string key)
+    private Component GetData(string key)
     {
       foreach(JObject item in Config["Objects"])
       {
-        ParameterData data = BuildDataFromJObject(item);
+        Component data = BuildDataFromJObject(item);
         if (data.Name == key) return data;
       }
@@ -59,6 +59,6 @@
     }
 
-    private ParameterData BuildDataFromJObject(JObject obj) {
-      ParameterData data = new ParameterData() {
+    private Component BuildDataFromJObject(JObject obj) {
+      Component data = new Component() {
         Name = obj["Name"]?.ToString(),
         Default = obj["Default"]?.ToObject<object>(),
@@ -76,5 +76,5 @@
 
       if (obj["Operators"] != null) {
-        data.Operators = new List<ParameterData>();
+        data.Operators = new List<Component>();
         foreach (JObject sp in obj["Operators"])
           data.Operators.Add(BuildDataFromJObject(sp));
@@ -84,5 +84,5 @@
     }
 
-    private T CreateObject<T>(ParameterData data) {
+    private T CreateObject<T>(Component data) {
       Type type = Type.GetType(data.Type);
       return (T)Activator.CreateInstance(type);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ConstrainedValueParameterTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ConstrainedValueParameterTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ConstrainedValueParameterTransformer.cs	(revision 17271)
@@ -8,5 +8,5 @@
 namespace HeuristicLab.Manufacture {
   public class ConstrainedValueParameterTransformer : ParameterBaseTransformer {
-    public override void InjectData(IParameter parameter, ParameterData data) {
+    public override void InjectData(IParameter parameter, Component data) {
       foreach (var x in parameter.Cast<dynamic>().ValidValues)
         if (x.GetType().Name == CastValue<string>(data.Default))
@@ -17,7 +17,7 @@
     }
 
-    public override ParameterData ExtractData(IParameter value) {
+    public override Component ExtractData(IParameter value) {
 
-      return new ParameterData() {
+      return new Component() {
         Name = value.Name,
         Default = value.ActualValue?.GetType().Name,
@@ -35,11 +35,11 @@
     }
 
-    private IList<ParameterData> GetParameterizedChilds(IParameter value) {
-      List<ParameterData> list = new List<ParameterData>();
+    private IList<Component> GetParameterizedChilds(IParameter value) {
+      List<Component> list = new List<Component>();
       var values = value.Cast<dynamic>().ValidValues;
       foreach(var x in values) {
         if (x is IParameterizedItem &&
             ((IParameterizedItem)x).Parameters.Any(p => !p.Hidden)) {
-          ParameterData tmp = Transformer.Extract(x);
+          Component tmp = Transformer.Extract(x);
           if (tmp.ParameterizedItems != null)
             list.AddRange(tmp.ParameterizedItems);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/LookupParameterTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/LookupParameterTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/LookupParameterTransformer.cs	(revision 17271)
@@ -8,9 +8,9 @@
 namespace HeuristicLab.Manufacture {
   public class LookupParameterTransformer : ParameterBaseTransformer {
-    public override ParameterData ExtractData(IParameter value) {
-      return new ParameterData() { Name = value.Name };
+    public override Component ExtractData(IParameter value) {
+      return new Component() { Name = value.Name };
     }
 
-    public override void InjectData(IParameter parameter, ParameterData data) {
+    public override void InjectData(IParameter parameter, Component data) {
       
     }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ParameterBaseTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ParameterBaseTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ParameterBaseTransformer.cs	(revision 17271)
@@ -8,10 +8,10 @@
 namespace HeuristicLab.Manufacture {
   public abstract class ParameterBaseTransformer : BaseTransformer {
-    public override ParameterData ExtractData(IItem value) => ExtractData(value.Cast<IParameter>());
-    public abstract ParameterData ExtractData(IParameter value);
+    public override Component ExtractData(IItem value) => ExtractData(value.Cast<IParameter>());
+    public abstract Component ExtractData(IParameter value);
 
-    public override void InjectData(IItem item, ParameterData data) => InjectData(item.Cast<IParameter>(), data);
+    public override void InjectData(IItem item, Component data) => InjectData(item.Cast<IParameter>(), data);
 
-    public abstract void InjectData(IParameter parameter, ParameterData data);
+    public abstract void InjectData(IParameter parameter, Component data);
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ParameterizedItemTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ParameterizedItemTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ParameterizedItemTransformer.cs	(revision 17271)
@@ -10,5 +10,5 @@
   public class ParameterizedItemTransformer : BaseTransformer {
     
-    public override void InjectData(IItem item, ParameterData data) {
+    public override void InjectData(IItem item, Component data) {
       IParameterizedItem pItem = item.Cast<IParameterizedItem>();
 
@@ -18,8 +18,8 @@
     }
 
-    public override ParameterData ExtractData(IItem value) {
-      List<ParameterData> list = new List<ParameterData>();
+    public override Component ExtractData(IItem value) {
+      List<Component> list = new List<Component>();
 
-      ParameterData obj = new ParameterData();
+      Component obj = new Component();
       obj.Name = value.ItemName;
       obj.Type = value.GetType().AssemblyQualifiedName;
@@ -29,5 +29,5 @@
       foreach (var param in value.Cast<IParameterizedItem>().Parameters) {
         if (!param.Hidden) {
-          ParameterData data = Transformer.Extract(param);
+          Component data = Transformer.Extract(param);
           obj[data.Name] = data;
           if(data.ParameterizedItems != null)
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ValueParameterTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ValueParameterTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/ParameterTransformer/ValueParameterTransformer.cs	(revision 17271)
@@ -9,11 +9,11 @@
   public class ValueParameterTransformer : ParameterBaseTransformer {
 
-    public override void InjectData(IParameter parameter, ParameterData data) => 
+    public override void InjectData(IParameter parameter, Component data) => 
       Transformer.Inject(parameter.ActualValue, data);
 
-    public override ParameterData ExtractData(IParameter value) {
-      ParameterData data = null;
+    public override Component ExtractData(IParameter value) {
+      Component data = null;
       if (value.ActualValue == null)
-        data = new ParameterData();
+        data = new Component();
       else
         data = Transformer.Extract(value.ActualValue);
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Template.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Template.cs	(revision 17269)
+++ 	(revision )
@@ -1,95 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Core;
-using Newtonsoft.Json;
-
-namespace HeuristicLab.Manufacture {   
-  /*
-  public class ParameterData { //Blueprint, Component,  ?
-    public string Name { get; set; }
-    public string Type { get; set; }
-    public IList<ParameterData> FreeParameters { get; set; }
-    public IList<ParameterData> StaticParameters { get; set; }
-
-  }*/
-
-  public class ParameterData {
-    public string Name { get; set; }
-    public string Type { get; set; }
-    public object Default { get; set; }
-    public string Path { get; set; }
-    public IList<object> Range { get; set; }
-
-    public IList<ParameterData> Parameters { get; set; }
-    public IList<ParameterData> Operators { get; set; }
-
-    [JsonIgnore]
-    public ParameterData this[string index] {
-      get {
-        if (Parameters == null) return null;
-        foreach (var p in Parameters)
-          if (p.Name == index) return p;
-        return null;
-      }
-      set {
-        if (Parameters == null) 
-          Parameters = new List<ParameterData>();
-        ParameterData data = this[index];
-        if (data != null && CheckConstraints(value))
-          Merge(data, value);
-        else
-          Parameters.Add(value);
-      }
-    }
-
-    public override bool Equals(object obj) {
-      if (!(obj is ParameterData)) 
-        return false;
-      else 
-        return obj.Cast<ParameterData>().Name == this.Name;
-    }
-
-    public override int GetHashCode() {
-      return Name.GetHashCode();
-    }
-
-    [JsonIgnore]
-    public IList<ParameterData> ParameterizedItems { get; set; }
-
-    [JsonIgnore]
-    public ParameterData Reference { get; set; }
-
-    #region Helper
-    public static void Merge(ParameterData target, ParameterData from) {
-      target.Name = from.Name ?? target.Name;
-      target.Type = from.Type ?? target.Type;
-      target.Range = from.Range ?? target.Range;
-      target.Path = from.Path ?? target.Path;
-      target.Default = from.Default ?? target.Default;
-      target.Reference = from.Reference ?? target.Reference;
-      target.Parameters = from.Parameters ?? target.Parameters;
-      target.ParameterizedItems = from.ParameterizedItems ?? target.ParameterizedItems;
-    }
-
-    private bool CheckConstraints(ParameterData data) => 
-      data.Range != null && data.Default != null && (
-      IsInRangeList(data.Range, data.Default) ||
-      IsInNumericRange<long>(data.Default, data.Range[0], data.Range[1]) ||
-      IsInNumericRange<double>(data.Default, data.Range[0], data.Range[1]));
-
-    private bool IsInRangeList(IEnumerable<object> list, object value) {
-      foreach (var x in list)
-        if (x.Equals(value)) return true;
-      return false;
-    }
-
-    private bool IsInNumericRange<T>(object value, object min, object max) where T : IComparable =>
-      (value != null && min != null && max != null && value is T && min is T && max is T &&
-        (((T)min).CompareTo(value) == -1 || ((T)min).CompareTo(value) == 0) &&
-        (((T)max).CompareTo(value) == 1 || ((T)max).CompareTo(value) == 0));
-    #endregion
-  }
-}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Transformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Transformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/Transformer.cs	(revision 17271)
@@ -49,5 +49,5 @@
     }
 
-    internal static void Inject(IItem item, ParameterData data) {
+    internal static void Inject(IItem item, Component data) {
       IEnumerable<ITypeTransformer> arr = Get(item.GetType());
       foreach (var transformer in arr)
@@ -55,9 +55,9 @@
     }
 
-    internal static ParameterData Extract(IItem item) {
+    internal static Component Extract(IItem item) {
       IEnumerable<ITypeTransformer> arr = Get(item.GetType());
-      ParameterData data = new ParameterData();
+      Component data = new Component();
       foreach (var transformer in arr)
-        ParameterData.Merge(data, transformer.Extract(item));
+        Component.Merge(data, transformer.Extract(item));
       return data;
     }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/BaseTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/BaseTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/BaseTransformer.cs	(revision 17271)
@@ -10,14 +10,14 @@
   public abstract class BaseTransformer : ITypeTransformer
   {
-    public ParameterData Extract(IItem value) {
-      ParameterData data = ExtractData(value);
+    public Component Extract(IItem value) {
+      Component data = ExtractData(value);
       data.Name = String.IsNullOrEmpty(data.Name) ? value.ItemName : data.Name;
       return data;
     }
 
-    public void Inject(IItem item, ParameterData data) => InjectData(item, data);
+    public void Inject(IItem item, Component data) => InjectData(item, data);
 
-    public abstract void InjectData(IItem item, ParameterData data);
-    public abstract ParameterData ExtractData(IItem value);
+    public abstract void InjectData(IItem item, Component data);
+    public abstract Component ExtractData(IItem value);
 
     #region Helper
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/DummyTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/DummyTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/DummyTransformer.cs	(revision 17271)
@@ -8,11 +8,11 @@
 namespace HeuristicLab.Manufacture {
   public class DummyTransformer : BaseTransformer {
-    public override void InjectData(IItem item, ParameterData data) {
+    public override void InjectData(IItem item, Component data) {
       // do nothing because the instance already exists and 
       // there are no values to inject
     }
 
-    public override ParameterData ExtractData(IItem value) => 
-      new ParameterData() { Default = value.GetType().Name };
+    public override Component ExtractData(IItem value) => 
+      new Component() { Default = value.GetType().Name };
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/EnumTypeTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/EnumTypeTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/EnumTypeTransformer.cs	(revision 17271)
@@ -10,11 +10,11 @@
   public class EnumTypeTransformer : BaseTransformer {
 
-    public override void InjectData(IItem item, ParameterData data) =>
+    public override void InjectData(IItem item, Component data) =>
       item.Cast<dynamic>().Value = Enum.Parse(
         item.GetType().GenericTypeArguments.First(), 
         CastValue<string>(data.Default));
 
-    public override ParameterData ExtractData(IItem value) {
-      ParameterData data = new ParameterData();
+    public override Component ExtractData(IItem value) {
+      Component data = new Component();
       object val = ((dynamic)value).Value;
       Type enumType = val.GetType();
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/MultiCheckedOperatorTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/MultiCheckedOperatorTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/MultiCheckedOperatorTransformer.cs	(revision 17271)
@@ -8,11 +8,11 @@
 namespace HeuristicLab.Manufacture {
   public class MultiCheckedOperatorTransformer : ParameterizedItemTransformer {
-    public override ParameterData ExtractData(IItem value) {
-      ParameterData data = base.ExtractData(value);
+    public override Component ExtractData(IItem value) {
+      Component data = base.ExtractData(value);
 
-      data.Operators = new List<ParameterData>();
+      data.Operators = new List<Component>();
       dynamic val = value.Cast<dynamic>();
       foreach (var op in val.Operators) {
-        data.Operators.Add(new ParameterData() {
+        data.Operators.Add(new Component() {
           Name = op.Name,
           Default = val.Operators.ItemChecked(op),
@@ -23,5 +23,5 @@
     }
 
-    public override void InjectData(IItem item, ParameterData data) {
+    public override void InjectData(IItem item, Component data) {
       base.InjectData(item, data);
 
@@ -32,5 +32,5 @@
     }
 
-    private bool GetOperatorState(string name, ParameterData data) {
+    private bool GetOperatorState(string name, Component data) {
       foreach(var op in data.Operators) {
         if (op.Name == name) return op.Default.Cast<bool>();
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/StringValueTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/StringValueTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/StringValueTransformer.cs	(revision 17271)
@@ -9,9 +9,9 @@
 namespace HeuristicLab.Manufacture {
   public class StringValueTransformer : BaseTransformer {
-    public override void InjectData(IItem item, ParameterData data) =>
+    public override void InjectData(IItem item, Component data) =>
       item.Cast<StringValue>().Value = CastValue<string>(data.Default);
 
-    public override ParameterData ExtractData(IItem value) => 
-      new ParameterData() {
+    public override Component ExtractData(IItem value) => 
+      new Component() {
         Default = value.Cast<StringValue>().Value
       };
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeArrayTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeArrayTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeArrayTransformer.cs	(revision 17271)
@@ -13,9 +13,9 @@
     where T : struct 
   {
-    public override void InjectData(IItem item, ParameterData data) => 
+    public override void InjectData(IItem item, Component data) => 
       CopyArrayData(item.Cast<ArrayType>(), CastValue<T[]>(data.Default));
 
-    public override ParameterData ExtractData(IItem value) => 
-      new ParameterData() {
+    public override Component ExtractData(IItem value) => 
+      new Component() {
         Default = value.Cast<ArrayType>().CloneAsArray()
       };
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeMatrixTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeMatrixTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeMatrixTransformer.cs	(revision 17271)
@@ -13,9 +13,9 @@
     where T : struct 
   {
-    public override void InjectData(IItem item, ParameterData data) => 
+    public override void InjectData(IItem item, Component data) => 
       CopyMatrixData(item.Cast<MatrixType>(), CastValue<T[,]>(data.Default));
 
-    public override ParameterData ExtractData(IItem value) =>
-      new ParameterData() {
+    public override Component ExtractData(IItem value) =>
+      new Component() {
         Default = value.Cast<MatrixType>().CloneAsMatrix()
       };
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeValueTransformer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeValueTransformer.cs	(revision 17269)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.Manufacture/TypeTransformer/ValueTypeValueTransformer.cs	(revision 17271)
@@ -12,9 +12,9 @@
     where T : struct {
 
-    public override void InjectData(IItem item, ParameterData data) =>
+    public override void InjectData(IItem item, Component data) =>
       item.Cast<ValueType>().Value = CastValue<T>(data.Default);
 
-    public override ParameterData ExtractData(IItem value) => 
-      new ParameterData() {
+    public override Component ExtractData(IItem value) => 
+      new Component() {
         Default = value.Cast<ValueType>().Value,
         Range = new object[] { default(T), GetMaxValue() }